import java.awt.Color;
import java.awt.*;
import javax.swing.*;
import java.io.Serializable;
/**
Servos: 
PWM-Periode: 50..100Hz <=> 0,02 .. 0,01s
PWM-Puls:     1..2ms   <=> 0,001 .. 0,002s
*/
public class Servo extends JPanel  implements Serializable, Runnable
{
    private long zeit;     //zuletzt gespeicherte Zeit, an der ein Puls gesendet wurde.
    private long periode;  //PWM-Periodendauer in Nanosekunden
    private long pwmpuls;  //PWM-Pulsbreite in Nanosekunden

    public void setPwmpuls(long pwmpuls)
    {
        this.pwmpuls = pwmpuls;
    }

    public long getPwmpuls()
    {
        return this.pwmpuls;
    }

    public void run()
    {
        while(true)
        {
            try
            {
                Thread.sleep(12);              
            }
            catch(Exception e)
            {
            }
            while(System.nanoTime()<zeit+periode);
            Parallelport.sende(128);
            while(System.nanoTime()<zeit+periode+pwmpuls);            
            Parallelport.sende(0);
            zeit=System.nanoTime();
        }
    }

    public Servo()
    {
        //optische Reprsentation als JavaBean:
        JLabel aufkleber = new JLabel("Servo");
        aufkleber.setForeground( Color.WHITE );
        add(aufkleber);
        setBackground( Color.BLUE );

        //Servofunktionalitt vorbereiten:
        zeit    = System.nanoTime();
        periode = 15000000;
        pwmpuls = 1500000; //Mittelstellung
        Thread thread = new Thread(this);
        thread.start();
    }

    public static void main(String[] args)
    {
        if(args.length!=1)
        {
            System.out.println("Servowinkel an D7 am Parallelport einstellen.");
            System.out.println("Benutzung:");
            System.out.println("Servo <pwmpuls 1000000..2000000 in Nanosekunden");
            System.out.println("Beispiel: (mittlere Position)");
            System.out.println("Servo 1500000");
        }
        else
        {
            Servo servo = new Servo();
            servo.setPwmpuls((long)Double.parseDouble(args[0]));

            while(true)
            {
                try
                {
                    Thread.sleep(200);
                }
                catch(Exception ee)
                {
                }
            }
        }
    }
}